/* ============================================================================================================ */
/*@8@F{ẐÂýđ@dCn@dqHg				@{F2010N0617()@*/
/* ------------------------------------------------------------------------------------------------------------ */
/*@ȻϲH8p(RY3048F-ONE TypeHFkldqϲݶذpCPUް)۸їpwb_̧					*/
/*@ِڑF.CN1(LED/7ē_p)`H8J2A.CN2(LED/7ē_{߼ݐp)`H8J3			*/
/* ============================================================================================================ */

/** QƊ֐̒` **/
void InitializeIO(void);								/* ϲݏݒ											*/
int ADConv(int ch);										/* A/Dϊٰ(َwFPӰ)					*/
void Wait1msec(void);									/* ϰ(҂ԁF1msec)							*/
void WaitMsec(int);										/* ϰ(҂ԁF?msec)							*/
int GetSW1(void);										/* ĸٽԎ擾										*/
int GetSW2(void);										/* ߯Ԏ擾									*/
int GetSW3(void);										/* ̫ľݻԎ擾										*/


/** L萔̒`(ϰ{p) **/
#define COUNT_START	1									/* ĊJn												*/
#define COUNT_STOP	0									/* Ē~												*/


/** L萔̒`(o͐p) **/
#define LED_AL_OFF	0xff								/* LED\FS										*/
#define LED_AL_ON	0x00								/* LED\FS_										*/

#define OE_ENABLE	0									/* (_)											*/
#define OE_DISABLE	1									/* 񋖉(_)										*/
#define FET_ENABLE	1									/* (_)											*/
#define FET_DISABLE	0									/* 񋖉(_)										*/

#define LED7SEG_ALL	PA.DR.BYTE							/* LED/7SegLEDo										*/
#define OE_7SEG		PB.DR.BIT.B7						/* OE:IC1/Output Enable/7SEGMENT LED					*/
#define OE_LED		PB.DR.BIT.B6						/* OE:IC2/Output Enable/LED								*/
#define LED7SEG_2	PB.DR.BIT.B5						/* 7Segment LED	2										*/
#define LED7SEG_1	PB.DR.BIT.B4						/* 7Segment LED	1										*/
#define A			0x01								/* 7Segment LEDFa	7Seg	Port						*/
#define B			0x02								/* 7Segment LEDFb	LED		PA							*/
#define C			0x04								/* 7Segment LEDFc	 a		 0							*/
#define D			0x08								/* 7Segment LEDFd	f b		5 1							*/
#define E			0x10								/* 7Segment LEDFe	 g		 6							*/
#define F			0x20								/* 7Segment LEDFf	e c		4 2							*/
#define G			0x40								/* 7Segment LEDFg	 d		 3							*/

#define SW1			P7.DR.BIT.B3						/* (J1-6)ĸٽF㎞=5VA=0V				*/
#define SW2			P7.DR.BIT.B5						/* (J1-4)߯F=0VA=5V				*/
#define SW3			P7.DR.BIT.B7						/* (J1-2)̫ľݻFߎ=0VAՌ=5V				*/
#define SW_LO		0									/* ̏ԁFd=0V									*/
#define SW_HI		1									/* ̏ԁFd=5V									*/


/** L萔̒` **/
#define True		1									/* ׸ސF^											*/
#define False		0									/* ׸ސFU											*/


/** ۰ٕϐ̒` **/								/* Fꂪ̂ž݁uCvKvɂȂB 			*/
const char LEDSegData[18] = { ~(A+B+C+D+E+F),			/* u0v\											*/
			 				  ~(B+C),					/* u1v\											*/
						      ~(A+B+G+E+D),				/* u2v\											*/
						      ~(A+B+G+C+D),				/* u3v\											*/
						      ~(F+G+B+C),				/* u4v\											*/
						      ~(A+F+G+C+D),				/* u5v\											*/
						      ~(A+F+G+C+D+E),			/* u6v\											*/
						      ~(A+B+C),					/* u7v\											*/
						      ~(A+B+C+D+E+F+G),			/* u8v\											*/
						      ~(A+B+C+D+F+G),			/* u9v\											*/
						      ~(A+B+C+E+F+G),			/* uAv\											*/
						      ~(C+D+E+F+G),				/* ubv\											*/
						      ~(D+E+G),					/* ucv\											*/
						      ~(B+C+D+E+G),				/* udv\											*/
						      ~(A+D+E+F+G),				/* uEv\											*/
						      ~(A+E+F+G),				/* uFv\											*/
						      ~(E+G),					/* urv\											*/
						      ~(G) };					/* u-v\											*/


/* ============================================================================================================ */
/*@֐FInitializeIO																						*/
/*@@FȂ(void)																							*/
/*@߂lFȂ(void)																							*/
/*@@eFϲݏlݒ																						*/
/*@@@@@PA=o߰(8bit)FLED{7LED_p															*/
/*@@@@@PB=o߰(8bit)FLED{7LED_p														*/
/*@@@@@P7=͐p߰(8bit)FADϊ(AN1){DI(P77,P75,P73)p												*/
/*@@@@@ADϊ(AN1)̐ݒFȉ̒ʂB																		*/
/*@@@@@@AD.CSŔAAD۰/ðڼ޽ݒ肷́B̗lȍ\ƂȂĂB							*/
/*@@@@@@@ADF(A/D׸)́AA/DϊIƂ׸ށBA/DϊIɁu1vɂȂB			*/
/*@@@@@@@ADIE(A/DĲȰ)́AA/Dϊ̏IŊݏ𔭐邩ǂݒ肷B́A	*/
/*@@@@@@@݂gpȂ̂Łu0vƂB																*/
/*@@@@@@@ADST(A/D)́AA/Dϊ̊Jn/~ݒ肷Bu0vŒ~Au1vŊJnB́A~	*/
/*@@@@@@@n߂̂Łu0vɐݒ肷B																		*/
/*@@@@@@@SCAN(Ӱ)́AӰނƂA/Dϊ̂AwقPӰނA/Dϊ̂w	*/
/*@@@@@@@B́APӰނȂ̂Łu0vɐݒ肷B													*/
/*@@@@@@@CKS(ۯڸ)́AA/DϊԂݒ肷Bu0v266ðāAu1v134ðĂ̎ԂɂȂB́A	*/
/*@@@@@@@u1vɐݒ肷B																				*/
/*@@@@@@@CH()ɂ́A̗lȈӖÂB															*/
/*@@@@@@@@CH2 CH1 CH0@PӰށ@Ӱ																*/
/*@@@@@@@@ 0   0   0 @AN0 @@@AN0																	*/
/*@@@@@@@@ 0   0   1 @AN1 @@@AN0+AN1																*/
/*@@@@@@@@ 0   1   0 @AN2 @@@AN0+AN1+AN2															*/
/*@@@@@@@@ 0   1   1 @AN3 @@@AN0+AN1+AN2+AN3														*/
/*@@@@@@@@ 1   0   0 @AN4 @@@AN4																	*/
/*@@@@@@@@ 1   0   1 @AN5 @@@AN4+AN5																*/
/*@@@@@@@@ 1   1   0 @AN6 @@@AN4+AN5+AN6															*/
/*@@@@@@@@ 1   1   1 @AN7 @@@AN4+AN5+AN6+AN7														*/
/*@@@@@@@@@ّI																			*/
/*@@@@@@@@ٰߑI																					*/
/*@@@@@ϰ(ITU1)																							*/
/*@@@@@@ITU1.TCR.BYTE = 0x23																				*/
/*@@@@@@@@@|CCLR1|CCLR0|CKEG1|CKEG0|TPSC2|TPSC1|TPSC0|												*/
/*@@@@@@@@@@                           0     1     1@ۯgӁ8(TCNT(϶)̊ƂȂۯ)*/
/*@@@@@@@@@@               0     0@Ă鴯ނ̑IFݒ́Aۯ̗オ					*/
/*@@@@@@@@@@   0     1@TCNT̸ر̎dFĒl̐ݒGRAɏ(GRA߱ϯƲ߯ķŸر)	*/
/*@@@@@@ITU1.GRA = 0x7800																					*/
/*@@@@@@@@@ǂĂTCNTرāAm点Ă炤ݒ肷B								*/
/*@@@@@@@@@@TCNT̸ۯ̓(24.576MHz)/8ɐݒ肵̂ŁA3.072MHzۯɂȂB				*/
/*@@@@@@@@@@3.072MHz̎Ȃ̂ŁA30720{Ƃ傤10ؕb(1/100b)ɂȂ̂ŁA					*/
/*@@@@@@@@@@GRA30720(16i7800h)ɐݒ肷ƁAJn1/100b׸ނB				*/
/*@@@@@@ITU.TSTR.BIT.STR1 = COUNT_START@ITU1̶ĊJnw												*/
/*@@@@@@FѸۯ=24.576MHz(RY3048FonȅꍇFƖkldq̎mF)							*/
/* ============================================================================================================ */
void InitializeIO(void)
{
	/* o͒[q̒` */
	PA.DR.BYTE = 0;										/* PAFްر											*/
	PA.DDR     = 0xff;									/* PAFS߰ı߯									*/
	PA.DR.BYTE = LED_AL_OFF;							/* PAFް(LED)									*/
	PB.DR.BYTE = 0;										/* PBFްر											*/
	PB.DDR     = 0xff;									/* PBFS߰ı߯									*/
														/* P7x́A8bit̓͐p߰āBo͐ݒ͂ȂB		*/

	/* ADް̒` */
	AD.DRD = 0;											/* ްڼ޽Ӱނر									*/
	AD.CSR.BIT.ADF = 0;									/* A/DϊI׸ނر									*/
	AD.CSR.BIT.ADIE = 0;								/* A/DϊI荞݂֎~							*/
	AD.CSR.BIT.ADST = 0;								/* A/Dϊ׸ނر									*/
	AD.CSR.BIT.SCAN = 0;								/* A/Dϊ͒PӰ									*/
	AD.CSR.BIT.CKS = 1;									/* ϊԂ́A134ð()							*/
	AD.CSR.BIT.CH = 0;									/* A/DΐAp鎞Ɏw							*/

	/* ϰ̒` */
	ITU1.TCR.BYTE     = 0x23;							/* ϰ1 ݒ											*/
	ITU1.GRA          = 0x0c00;							/* ϰ1 1/100b(0x7800)A1/1000b(0x0c00)F24.576MHz	*/
	ITU.TSTR.BIT.STR1 = COUNT_START;					/* ϰ1 ĊJn										*/
}


/* ============================================================================================================ */
/*@֐FADConv																								*/
/*@@Fint ch = ADϊ߰Ă̎w(0`7)																		*/
/*@߂lFA/Dϊl																							*/
/*@@eFA/Dϊ̖{ٰ	@																				*/
/*@@@@@A/Dϊ֐̎ǵAAN1߰(J1-8)gpꍇAADConv(1)ƂȂB							*/
/* ============================================================================================================ */
int ADConv(int ch)
{
	/* ۰ٕϐ̒` */
	int ADdata;											/* A/Dϊl											*/


	AD.CSR.BIT.CH = ch;									/* A/DΐAAN1߰(J1-8)gp					*/
	AD.CSR.BIT.ADST = 1;								/* A/DϊJn											*/
	while( !AD.CSR.BIT.ADF ) ;							/* ϊI҂											*/
	AD.CSR.BIT.ADF = 0;									/* A/DϊI׸ނر									*/
	switch(ch & 0x03){									/* AD߰Ăɏ]AϊꂽlϐɊi[			*/
		case 0:
			ADdata = AD.DRA >> 6;						/* AN0/AN4̏ꍇ́AADDR=ADDRA(10ޯčl)				*/
			break;
		case 1:
			ADdata = AD.DRB >> 6;						/* AN1/AN5̏ꍇ́AADDR=ADDRB(10ޯčl)				*/
			break;
		case 2:
			ADdata = AD.DRC >> 6;						/* AN2/AN6̏ꍇ́AADDR=ADDRC(10ޯčl)				*/
			break;
		case 3:
			ADdata = AD.DRD >> 6;						/* AN3/AN7̏ꍇ́AADDR=ADDRD(10ޯčl)				*/
			break;
	}
	return( ADdata );									/* ߂l(A/Dϊl)̾								*/
}


/* ============================================================================================================ */
/*@֐FWait1sec																							*/
/*@@FȂ(void)																							*/
/*@߂lFȂ(void)																							*/
/*@@eF҂ԏ																						*/
/*@Q@lFIMFA - TCNT = GRA̎A1ɂȂ																		*/
/*@@@@FTSR - Timer Status Register																			*/
/* ============================================================================================================ */
void Wait1msec(void)
{
	/*  */
	for(;;){											/* mF()ٰߊJn								*/
		if( ITU1.TSR.BIT.IMFA != 0 ) break;				/* 1/1000b҂											*/
	}													/* mF()ٰߏI								*/
	ITU1.TSR.BIT.IMFA = 0;								/* ޯ̧ر									*/
}


/* ============================================================================================================ */
/*@֐FWaitMsec																							*/
/*@@Fint msec@b̎w(PʁFmsec)																	*/
/*@߂lFȂ(void)																							*/
/*@@eFwb̑҂ԏ																				*/
/* ============================================================================================================ */
void WaitMsec(int msec)
{
	/* ۰ٕϐ̒` */
	int iCnt;											/* 													*/


	/*  */
	if( msec < 0 ) return;								/* wb̎́AȂ						*/
	for( iCnt = 0 ; iCnt < msec ; iCnt++ ) Wait1msec();	/* 1msecw񐔌JԂ								*/
}


/* ============================================================================================================ */
/*@֐FGetSW1																								*/
/*@@FȂ(void)																							*/
/*@߂lFSW_OFFASW_ON																						*/
/*@@eFĸٽ(SW1)̏Ԏ擾Fްɓ|ɵ݁Aɓ|ɵ̂ƂB					*/
/* ============================================================================================================ */
int GetSW1(void)
{
	return( SW1 );										/* ĸٽԂ̎擾									*/
}


/* ============================================================================================================ */
/*@֐FGetSW2																								*/
/*@@FȂ(void)																							*/
/*@߂lFSW_OFFASW_ON																						*/
/*@@eF߯(SW2)̏Ԏ擾Fɵ݁Aɵ̂ƂB										*/
/* ============================================================================================================ */
int GetSW2(void)
{
	return( SW2 );										/* ߯Ԃ̎擾									*/
}


/* ============================================================================================================ */
/*@֐FGetSW3																								*/
/*@@FȂ(void)																							*/
/*@߂lFSW_OFFASW_ON																						*/
/*@@eF̫ľݻ(SW3)̏Ԏ擾FߏԂŵ݁AՌԂŵ̂ƂB@										*/
/* ============================================================================================================ */
int GetSW3(void)
{
	return( SW3 );										/* ̫ľݻԂ̎擾									*/
}
